const app = Vue.createApp({
  setup() {
    document.body.removeAttribute('hidden')
  },
  data () {
    return {
      comments: []
    }
  },
  methods: {
    getStyle(comment) {
      const baseStyle = OneSDK.getCommentStyle(comment)
      baseStyle.borderColor = `rgb(${comment.color.r},${comment.color.g},${comment.color.b})`;
      return baseStyle
    }
  },
  mounted () {
    const WAIT_DURATION = OneSDK.getStyleVariable('--lcv-wait-duration', 100, parseInt)
    const INTERVAL = OneSDK.getStyleVariable('--lcv-enter-duration', 160, parseInt) + WAIT_DURATION
    const LIFE_TIME = OneSDK.getStyleVariable('--lcv-lifetime', 5000, parseInt) + WAIT_DURATION
    
    commentIndex = 0
    OneSDK.setup({
      mode: 'diff',
      disabledDelay: true
    })
    const queue = []
    OneSDK.subscribe({
      action: 'comments',
      callback: (comments) => {
        if (comments.length !== 0) {
          queue.push(...comments)
        }
      }
    })

    let time = 0
    const check = () => {
      const now = Date.now()
      if (time + INTERVAL < now) {
        if (queue.length !== 0) {
          time = now
          const comment = queue.shift()
          this.comments.shift()
          this.comments.push(comment)
        } else if (now - time > LIFE_TIME) {
          this.comments.shift()
        }
      }
      requestAnimationFrame(check)
    }
    OneSDK.connect()
    check()
  },
})
OneSDK.ready().then(() => {
  app.mount("#container");
})

